<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.jsowell.pile.mapper.ThirdPartyStationRelationMapper">

    <resultMap type="com.jsowell.pile.domain.ThirdPartyStationRelation" id="ThirdPartyStationRelationResult">
        <result property="id"    column="id"    />
        <result property="stationId"    column="station_id"    />
        <result property="thirdPartyType"    column="third_party_type"    />
        <result property="createTime"    column="create_time"    />
        <result property="createBy"    column="create_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="delFlag"    column="del_flag"    />
    </resultMap>

    <sql id="selectThirdPartyStationRelationVo">
        select id, station_id, third_party_type, create_time, create_by, update_time, update_by, del_flag from thirdparty_station_relation
    </sql>

    <sql id="Base_Column_List" >
        id, station_id, third_party_type, create_time, create_by, update_time, update_by, del_flag
    </sql>

    <select id="selectThirdPartyStationRelationList" parameterType="com.jsowell.pile.domain.ThirdPartyStationRelation" resultMap="ThirdPartyStationRelationResult">
        <include refid="selectThirdPartyStationRelationVo"/>
        <where>
            <if test="stationId != null "> and station_id = #{stationId}</if>
            <if test="thirdPartyType != null  and thirdPartyType != ''"> and third_party_type = #{thirdPartyType}</if>
        </where>
    </select>

    <select id="selectThirdPartyStationRelationById" parameterType="Long" resultMap="ThirdPartyStationRelationResult">
        <include refid="selectThirdPartyStationRelationVo"/>
        where id = #{id}
    </select>

    <insert id="insertThirdPartyStationRelation" parameterType="com.jsowell.pile.domain.ThirdPartyStationRelation" useGeneratedKeys="true" keyProperty="id">
        insert into thirdparty_station_relation
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="stationId != null">station_id,</if>
            <if test="thirdPartyType != null">third_party_type,</if>
            <if test="createTime != null">create_time,</if>
            <if test="createBy != null">create_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="delFlag != null">del_flag,</if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="stationId != null">#{stationId},</if>
            <if test="thirdPartyType != null">#{thirdPartyType},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="delFlag != null">#{delFlag},</if>
        </trim>
    </insert>

    <update id="updateThirdPartyStationRelation" parameterType="com.jsowell.pile.domain.ThirdPartyStationRelation">
        update thirdparty_station_relation
        <trim prefix="SET" suffixOverrides=",">
            <if test="stationId != null">station_id = #{stationId},</if>
            <if test="thirdPartyType != null">third_party_type = #{thirdPartyType},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="delFlag != null">del_flag = #{delFlag},</if>
        </trim>
        where station_id = #{stationId,jdbcType=BIGINT}
    </update>

    <delete id="deleteThirdPartyStationRelationById" parameterType="Long">
        delete from thirdparty_station_relation where id = #{id}
    </delete>

    <delete id="deleteThirdPartyStationRelationByIds" parameterType="String">
        delete from thirdparty_station_relation where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>

    <select id="selectRelationInfo" resultType="com.jsowell.pile.vo.base.ThirdPartyStationRelationVO">
        select
            t1.station_id as stationId,
            t1.third_party_type as thirdPartyType,
            t2.url_address as urlAddress,
            t2.operator_id as operatorId,
            t2.operator_secret as operatorSecret,
            t2.sign_secret as signSecret,
            t2.data_secret as dataSecret,
            t2.data_secret_IV as dataSecretIv
        from thirdparty_station_relation t1 join thirdparty_setting_info t2 on t1.third_party_type = t2.type
        where t1.del_flag = '0'
        <if test="stationId != null">
            and t1.station_id = #{stationId,jdbcType=BIGINT}
        </if>
        <if test="thirdPartyType != null and thirdPartyType != ''">
            and t1.third_party_type = #{thirdPartyType,jdbcType=VARCHAR}
        </if>
        limit 1
    </select>
</mapper>